SystemOrganization addCategory: #RPSS!

WAComponent subclass: #RPSS_Main
	instanceVariableNames: 'system administrator page'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS'!

!RPSS_Main class methodsFor: 'testing' stamp: 'BogatchevOleg 10/16/2011 13:21'!
canBeRoot
	^true.! !

!RPSS_Main methodsFor: 'rendering' stamp: 'TimLenertz 10/25/2011 12:56'!
currentUser
	^ RPSS_System uniqueInstance getUserWithEmail: self session visitor email! !

!RPSS_Main methodsFor: 'initialization' stamp: 'TimLenertz 10/25/2011 12:56'!
initialize 
	super initialize.
	system := RPSS_System uniqueInstance.
	system isInitialized 
	ifFalse: 
	[
		administrator := RPSS_Administrator new.
	].
	page := nil.
	! !

!RPSS_Main methodsFor: 'rendering' stamp: 'TimLenertz 10/25/2011 10:30'!
renderContentOn: html
		html div class: #header; with: [self renderHeader: html].
		html div class: #menu; with: [self renderMenu: html].
		html div class: #main; with: [self renderMain: html].
		html div class: #footer; with: [self renderFooter:html].! !

!RPSS_Main methodsFor: 'rendering' stamp: 'BogatchevOleg 10/18/2011 20:50'!
renderFirstAdministrator: html
	html form: 
	[
		html paragraph: 'Your e-mail adress:'.
		html textInput callback: [ :value | administrator email: value ].
		html paragraph: 'Your password:'.
		html textInput
			type: 'password';
			callback: [ :value | administrator password: value ].
		html break.
		html paragraph: 'Email confirmation'.
		html checkbox
			value: true;
			callback: [ :value | administrator confirmEmail: value ].
		html break.
		html paragraph: 'Email confirmation of every new user'.
		html checkbox
			value: true;
			callback: [ :value | system userApprovedByAdmin: value ].
		html break.
		html submitButton
			callback: [ administrator create: html];
			value: 'Initialize!!'
	]! !

!RPSS_Main methodsFor: 'rendering' stamp: 'TimLenertz 10/25/2011 10:54'!
renderFooter: html
	html text: ''.! !

!RPSS_Main methodsFor: 'rendering' stamp: 'TimLenertz 10/25/2011 12:56'!
renderHeader: html
	html heading: 'RolePlay Support System'.
	self session visitor isLogedIn ifTrue: [html text: 'Logged in as ', self session visitor email] ifFalse: [].! !

!RPSS_Main methodsFor: 'rendering' stamp: 'TimLenertz 10/25/2011 12:57'!
renderMain: html
	system isInitialized 
	ifTrue: 
	[
		self session visitor message = ''
		ifTrue: 
		[
			self session visitor module = nil
			ifTrue: 
			[
				html paragraph: 'Welcome to RPSS by group 9, system is ready'.
				html paragraph: 'Please login or create a new user'.
			]
			ifFalse: 
			[	
				html render: self session visitor module.
			].
		]
		ifFalse: 
		[
			self renderMessage: html.
		].	
	]
	ifFalse: 
	[
		html paragraph: 'System is not yet initialized, please input the administrator data'.
		self renderFirstAdministrator: html.
	].! !

!RPSS_Main methodsFor: 'rendering' stamp: 'TimLenertz 10/25/2011 14:08'!
renderMenu: html
	self session visitor isLogedIn 
	ifTrue: 
	[
			html paragraph: [html anchor callback: [self session visitor setModule: RPSS_CharClassList new]; with: 'Character Classes'].
			self session visitor isAdministrator 
			ifTrue: 
			[
				html paragraph: [html anchor callback: [self session visitor setModule: RPSS_AdminPanel new. self session visitor module setPage:'approvals']; with: 'Pending approvals'].
			]
			ifFalse: 
			[
		
			].
			html paragraph: [html anchor callback: [self session visitor setModule: RPSS_UserPage new. self session visitor module setPage: 'personal']; with: 'Personal data'].
			html paragraph: [html anchor callback: [self session visitor logout]; with: 'Logout']..
	]
	ifFalse: 
	[
		html paragraph: [html anchor callback: [self session visitor setModule: self session visitor.]; with: 'Login'].
		html paragraph: [html anchor callback: [self session visitor setModule: RPSS_UserCreation new]; with: 'Register'].
	].
! !

!RPSS_Main methodsFor: 'rendering' stamp: 'TimLenertz 10/25/2011 12:59'!
renderMessage:html
	html paragraph: 'System message: ', self session visitor message.
	self session visitor setMessage: ''.! !

!RPSS_Main methodsFor: 'rendering' stamp: 'TimLenertz 10/25/2011 12:13'!
style 
	^ '
.header {
	height: 100px;
	width: 100%;
	position: relative;
	vertical-align: top;
}
.menu {
	width: 100px;
	position: relative;
	float: left;
	left: 0px;
	top: 0px;
}
.footer{
	width: 100%;
	position: static;
	vertical-align: bottom;
	clear: both;
	float: none;
	height: 100px;
}
.main {
	position: relative;
	float: left;
	left: 0px;
	top: 0px;
}'! !

WAComponent subclass: #RPSS_SiteModule
	instanceVariableNames: 'visitor page'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS'!

RPSS_SiteModule subclass: #RPSS_AdminPanel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS'!

!RPSS_AdminPanel methodsFor: 'initialization' stamp: 'BogatchevOleg 10/21/2011 22:40'!
initialize 
	super initialize.
	page := 'approvals'.! !

!RPSS_AdminPanel methodsFor: 'rendering' stamp: 'BogatchevOleg 10/21/2011 23:02'!
renderContentOn: html
	|system|
	system := RPSS_System uniqueInstance.
	html paragraph: 'New users waiting to be approved:'.
	RPSS_System uniqueInstance usersToApprove do: [ :user |
	html form: [
		html text: user email.
		html submitButton value: 'Approve'; callback: [system approveUser: user email].
		html submitButton value: 'Deny'; callback: [system denyUser: user email].
		html break.
	]
]! !

RPSS_SiteModule subclass: #RPSS_CharClassAttributeEditor
	instanceVariableNames: 'attribute characterClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS'!

!RPSS_CharClassAttributeEditor methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 19:10'!
attribute
	attribute ifNil: [attribute := RPSS_CharacterClassAttribute new].
	^ attribute! !

!RPSS_CharClassAttributeEditor methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 17:06'!
attribute: anObject
	attribute := anObject! !

!RPSS_CharClassAttributeEditor methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 17:54'!
characterClass
	^ characterClass! !

!RPSS_CharClassAttributeEditor methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 17:54'!
characterClass: anObject
	characterClass := anObject! !

!RPSS_CharClassAttributeEditor methodsFor: 'as yet unclassified' stamp: 'TimLenertz 10/25/2011 19:03'!
modifyCalculator
	! !

!RPSS_CharClassAttributeEditor methodsFor: 'as yet unclassified' stamp: 'TimLenertz 10/25/2011 19:03'!
modifyMaxCalculator
	! !

!RPSS_CharClassAttributeEditor methodsFor: 'as yet unclassified' stamp: 'TimLenertz 10/25/2011 19:17'!
renderContentOn: html
	html paragraph: 'Attribute Editor'; break.
	html form: [
		html submitButton value: 'Save'; callback: [self answer: true].
		html cancelButton value: 'Cancel'; callback: [self answer: false].
		html break; break.
		
		html text: 'Initial value: '.
		html textInput value: ''; callback: [:value | self attribute initialValue: value].
		html break.
		html text: '(If not set, then players will have to define a value on character creation.)'; break; break.
		
		html text: 'Minimum: '.
		html textInput value: ''; callback: [:value | self attribute minValue: value].
		html break.
		
		html text: 'Maximum: '.
		html textInput value: ''; callback: [:value | self attribute maxValue: value].
		html break.		
		
		html text: 'Can be modified by player: '.
		html checkbox value: false; callback: [:value | self attribute modifiable: value].
		html break.
		
		html text: 'Takes random values: '.
		html checkbox value: false; callback: [:value | self attribute random value].
		html break; break.
		
		html text: 'Dynamic value: '.
		(self attribute calculator = nil) ifTrue: [
			html text: 'not set'.
		] ifFalse: [
			html text: 'set'.
			html button value: 'Remove'; callback: [self attribute calculator: nil]
		].
		html button value: 'Set'; callback: [self modifyCalculator].
		html break.
		
		html text: 'Dynamic maximum value: '.
		(self attribute calculator = nil) ifTrue: [
			html text: 'not set'.
		] ifFalse: [
			html text: 'set'.
			html button value: 'Remove'; callback: [self attribute calculator: nil]
		].
		html button value: 'Set'; callback: [self modifyMaxCalculator].
	]! !

RPSS_SiteModule subclass: #RPSS_CharClassEditor
	instanceVariableNames: 'characterClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS'!

!RPSS_CharClassEditor methodsFor: 'as yet unclassified' stamp: 'TimLenertz 10/25/2011 18:22'!
addAttribute: name
	|editor|
	name ifNotNil: [
		editor := RPSS_CharClassAttributeEditor new.
		editor characterClass: characterClass.
		(self call: editor) ifTrue: [
			characterClass attributes at: name put: (editor attribute)
		] ifFalse: [].	
	]! !

!RPSS_CharClassEditor methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 14:24'!
characterClass
	characterClass ifNil: [characterClass := RPSS_CharacterClass new].
	^ characterClass! !

!RPSS_CharClassEditor methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 14:21'!
characterClass: anObject
	characterClass := anObject! !

!RPSS_CharClassEditor methodsFor: 'as yet unclassified' stamp: 'TimLenertz 10/25/2011 18:22'!
modifyAttribute: attributeName
	|object editor|
	object := characterClass attributes at: attributeName.
	editor := RPSS_CharClassAttributeEditor new.
	editor characterClass: characterClass.
	editor attribute: (characterClass attributes at: attributeName).
	^ self call: editor! !

!RPSS_CharClassEditor methodsFor: 'as yet unclassified' stamp: 'TimLenertz 10/25/2011 18:23'!
renderContentOn: html
	html paragraph: 'Character class editor'.
	html form: [
		html submitButton value: 'Save'; callback: [self answer: true].
		html cancelButton value: 'Cancel'; callback: [self answer: false].
		html break; break.
		
		html text: 'Title: '.
		html textInput value: self characterClass title; callback: [:value | self characterClass title: value].
		html break; break.
		
		html text: 'Attributes:'; break.
		html button value: 'Add Attribute'; callback: [self addAttribute: (self request: 'Name for new attribute?')].

		self characterClass attributes keysDo: [ :attribute |
			html break.
			html text: attribute.
			html button value: 'Modify'; callback: [self modifyAttribute: attribute].
			html button value: 'Remove'; callback: [self characterClass attributes removeKey: attribute].
		].
	].! !

RPSS_SiteModule subclass: #RPSS_CharClassList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS'!

!RPSS_CharClassList methodsFor: 'rendering' stamp: 'TimLenertz 10/25/2011 14:39'!
addCharacterClass
	|editor|
	editor := RPSS_CharClassEditor new.
	(self call: editor) ifTrue: [
		self session user characterClasses add: editor characterClass
	] ifFalse: [].! !

!RPSS_CharClassList methodsFor: 'initialization' stamp: 'BogatchevOleg 10/24/2011 14:40'!
initialize 
	super initialize.! !

!RPSS_CharClassList methodsFor: 'rendering' stamp: 'TimLenertz 10/25/2011 14:32'!
modifyCharacterClass: characterClass
	|editor|
	editor := RPSS_CharClassEditor new.
	editor characterClass: characterClass.
	self call: editor.! !

!RPSS_CharClassList methodsFor: 'rendering' stamp: 'TimLenertz 10/25/2011 14:31'!
removeCharacterClass: characterClass
	self session user characterClasses remove: characterClass ifAbsent: [].! !

!RPSS_CharClassList methodsFor: 'rendering' stamp: 'TimLenertz 10/25/2011 14:29'!
renderContentOn: html
	html paragraph: 'Character classes:'.
	html form: [
		html button value: 'Add'; callback: [self addCharacterClass].
		self session user characterClasses do: [ :class |
			html break.
			html text: class title.
			html button value: 'Remove'; callback: [self removeCharacterClass: class].
			html button value: 'Modify'; callback: [self modifyCharacterClass: class].
		]
	]
	! !

!RPSS_SiteModule methodsFor: 'initialization' stamp: 'TimLenertz 10/25/2011 12:59'!
initialize
	super initialize.
	visitor := self session visitor.! !

!RPSS_SiteModule methodsFor: 'accessing' stamp: 'BogatchevOleg 10/21/2011 16:39'!
setPage: aPage
	page := aPage.! !

RPSS_SiteModule subclass: #RPSS_UserCreation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS'!

!RPSS_UserCreation methodsFor: 'services' stamp: 'BogatchevOleg 10/22/2011 17:48'!
confirmCreation: anEmail with: html
	|system user urlApp urlDen|	
	system := RPSS_System uniqueInstance.
	user := system getUserWithEmail: anEmail.
	user markEmailConfirmed.
	system isUserApprovedByAdmin
	ifTrue: 
	[
		urlApp := html actionUrl copy.
		urlApp addField: (html callbacks store: (WAActionCallback on: [ system approveUser: anEmail ])).
		urlDen := html actionUrl copy.
		urlDen addField: (html callbacks store: (WAActionCallback on: [ system denyUser: anEmail ])).
		(RPSS_MailSender uniqueInstance) sendApprovalToAdmin: urlApp and: urlDen for: anEmail. 
	]
	ifFalse:
	[
		user approveByAdministrator.
	].
	visitor setMessage: 'User approved'.
	! !

!RPSS_UserCreation methodsFor: 'services' stamp: 'BogatchevOleg 10/20/2011 23:40'!
confirmEmail: anEmail
	|system user|	
	system := RPSS_System uniqueInstance.
	user := system getUserWithEmail: anEmail.
	user markEmailConfirmed.
	page := 'emailConfirm'.! !

!RPSS_UserCreation methodsFor: 'services' stamp: 'BogatchevOleg 10/22/2011 17:46'!
create: html
	|system url mail newUser|
	system := RPSS_System uniqueInstance.
	mail := RPSS_MailSender uniqueInstance.
	url := html actionUrl copy.
	url addField: (html callbacks store: (WAActionCallback on: [ self confirmEmail: visitor email ])).
	(system verifyPassword: visitor password) & (system verifyEmail: visitor email)
	ifTrue: 
	[
		(system isEmailOccupied: visitor email)
		ifFalse: 
		[
			newUser := RPSS_User new.
			newUser fromVisitor: visitor.
			system addUser: newUser.
			mail sendEmailConfirmationTo: visitor email withUrl: url.
			visitor setMessage: 'Please confirm your email!!'.
		]
		ifTrue: 
		[
			visitor setMessage: 'This email is already taken!!'.
		].
	]
	ifFalse: 
	[
		visitor setMessage: 'Wrong email or password!!'.
	].! !

!RPSS_UserCreation methodsFor: 'initialization' stamp: 'BogatchevOleg 10/20/2011 23:13'!
initialize 
	super initialize.
	page := 'RegisterForm'.! !

!RPSS_UserCreation methodsFor: 'rendering' stamp: 'BogatchevOleg 10/20/2011 23:33'!
renderContentOn: html
	page = 'RegisterForm'
	ifTrue:
	[
		self renderRegistrationForm: html.
	].
	page = 'emailConfirm'
	ifTrue: 
	[
		self renderEmailConfirmation: html.
	]! !

!RPSS_UserCreation methodsFor: 'rendering' stamp: 'BogatchevOleg 10/20/2011 23:30'!
renderEmailConfirmation: html
	|system|
	system := RPSS_System uniqueInstance.	
	html paragraph: 'Thank you for confirming your email'.
	system userApprovedByAdmin 
	ifTrue: 
	[
		self confirmCreation: visitor email with: html. 
	
	
		html paragraph: 'Administrator will approve your registration shortly'.
	].! !

!RPSS_UserCreation methodsFor: 'rendering' stamp: 'BogatchevOleg 10/20/2011 23:34'!
renderRegistrationForm: html
	html form: 
	[
		html paragraph: 'Your e-mail adress:'.
		html textInput callback: [ :value | visitor email: value ].
		html paragraph: 'Your password:'.
		html textInput
			type: 'password';
			callback: [ :value | visitor password: value ].
		html break.
		html submitButton
			callback: [ self create: html];
			value: 'Register!!'
	].! !

RPSS_SiteModule subclass: #RPSS_UserPage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS'!

!RPSS_UserPage methodsFor: 'services' stamp: 'BogatchevOleg 10/22/2011 17:55'!
changeEmail: html
	|system mail url|
	mail := RPSS_MailSender uniqueInstance.
	system := RPSS_System uniqueInstance.
	((system verifyEmail: visitor tempEmail) &  ((system isEmailOccupied: visitor tempEmail) not))
	ifTrue:
	[
		url := html actionUrl copy.
		url addField: (html callbacks store: (WAActionCallback on: [ self confirmEmailChange: visitor tempEmail ])).
		mail sendEmailChangeTo: visitor email with: visitor tempEmail url: url.
	].
	visitor setMessage: 'You will receive a confirmation email with a link to confirm your change.'.! !

!RPSS_UserPage methodsFor: 'services' stamp: 'BogatchevOleg 10/22/2011 18:23'!
changePassword: html
	|system mail url|
	mail := RPSS_MailSender uniqueInstance.
	system := RPSS_System uniqueInstance.
	(system verifyPassword: visitor tempPassword)
	ifTrue:
	[
		url := html actionUrl copy.
		url addField: (html callbacks store: (WAActionCallback on: [ self confirmPasswordChange: visitor tempPassword])).
		mail sendPasswordChangeTo: visitor email url: url.
	].
	visitor setMessage: 'You will receive a confirmation email with a link to confirm your change.'.! !

!RPSS_UserPage methodsFor: 'services' stamp: 'BogatchevOleg 10/22/2011 17:09'!
confirmEmailChange: aNewEmail
	|system user|
	system := RPSS_System uniqueInstance.
	user := system getUserWithEmail: visitor email.
	system transferUserFrom: user email to: aNewEmail. 
	visitor setMessage: 'You successfuly changed your email'.! !

!RPSS_UserPage methodsFor: 'services' stamp: 'BogatchevOleg 10/22/2011 18:18'!
confirmPasswordChange: aNewPassword
	|system user|
	system := RPSS_System uniqueInstance.
	user := system getUserWithEmail: visitor email.
	user password: aNewPassword.
	visitor setMessage: 'You successfuly changed your password'.! !

!RPSS_UserPage methodsFor: 'initialization' stamp: 'BogatchevOleg 10/21/2011 16:26'!
initialize 
	super initialize.
	page := 'overview'.! !

!RPSS_UserPage methodsFor: 'rendering' stamp: 'BogatchevOleg 10/22/2011 16:40'!
renderChangeEmail: html
	html paragraph: 'Please input your new email'.
	html form: 
	[
		html textInput callback: [:value | visitor tempEmail: value].
		html break.
		html submitButton callback: [self changeEmail: html.]; value: 'Modify!!'.
	].! !

!RPSS_UserPage methodsFor: 'rendering' stamp: 'BogatchevOleg 10/22/2011 18:25'!
renderChangePassword: html
	html paragraph: 'Please input your new password'.
	html form: 
	[
		html textInput type: 'password'; callback: [:value | visitor tempPassword: value].
		html break.
		html submitButton callback: [self changePassword: html.]; value: 'Modify!!'.
	].! !

!RPSS_UserPage methodsFor: 'rendering' stamp: 'BogatchevOleg 10/22/2011 12:19'!
renderContentOn: html
	page = 'overview'
	ifTrue: 
	[
		html paragraph: 'Overview'.
	].
	page = 'personal'
	ifTrue: 
	[
		self renderPersonal: html.
	].
	page = 'changePassword'
	ifTrue:  
	[
		self renderChangePassword: html.
	].
	page = 'changeEmail'
	ifTrue: 
	[
		self renderChangeEmail: html.
	].! !

!RPSS_UserPage methodsFor: 'rendering' stamp: 'BogatchevOleg 10/22/2011 15:34'!
renderPersonal: html
	html paragraph: [html anchor callback: [page := 'changeEmail']; with: 'Change email'].
	html paragraph: [html anchor callback: [page := 'changePassword']; with: 'Change password'].! !

WAComponent subclass: #RPSS_Visitor
	instanceVariableNames: 'email administrator password confirmEmail message logedIn module tempEmail tempPassword'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS'!

RPSS_Visitor subclass: #RPSS_Administrator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS'!

!RPSS_Administrator methodsFor: 'instance creation' stamp: 'BogatchevOleg 10/19/2011 20:03'!
confirmCreation
	|system newAdmin|
	system := RPSS_System uniqueInstance.
	(system isEmailOccupied: email)
	ifFalse: 
	[
		newAdmin := RPSS_User new.
		newAdmin email: email.
		newAdmin password: password.
		newAdmin markEmailConfirmed.
		newAdmin markAsAdministrator.
		newAdmin approveByAdministrator.
		system addUser: newAdmin.
		system finishInitialization.
		system setFirstAdministrator: newAdmin.
	]
	ifTrue: 
	[
		message := 'emailOccupied'.
	].
! !

!RPSS_Administrator methodsFor: 'instance creation' stamp: 'BogatchevOleg 10/22/2011 17:43'!
create: html
	|system url mail|
	system := RPSS_System uniqueInstance.
	mail := RPSS_MailSender uniqueInstance.
	url := html actionUrl copy.
	url addField: (html callbacks store: (WAActionCallback on: [ self confirmCreation ])).
	(system verifyPassword: password) & (system verifyEmail: email)
	ifTrue: 
	[
		mail sendEmailConfirmationTo: email withUrl: url.
	].
	self setMessage: 'Please confirm your email.'.
	! !

!RPSS_Administrator methodsFor: 'initialization' stamp: 'BogatchevOleg 10/17/2011 22:23'!
initialize
	super initialize.
	! !

!RPSS_Administrator methodsFor: 'initialization' stamp: 'TimLenertz 10/25/2011 13:45'!
initializeWithEmail: em password: pw
	super initialize.
	email := em.
	password := pw.
	administrator := true.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/21/2011 10:23'!
administrator: value
	administrator := value.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/17/2011 11:59'!
confirmEmail
	^confirmEmail.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/17/2011 12:00'!
confirmEmail: aConfirm
	confirmEmail := aConfirm.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/17/2011 11:49'!
email
	^email.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/17/2011 11:49'!
email: anEmail
	email := anEmail.! !

!RPSS_Visitor methodsFor: 'initialization' stamp: 'BogatchevOleg 10/21/2011 10:24'!
fromUser: anEmail
	|system user|
	system := RPSS_System uniqueInstance.
	user := system getUserWithEmail: anEmail.
	self email: user email.
	self password: user password.
	self administrator: user administrator.! !

!RPSS_Visitor methodsFor: 'initialization' stamp: 'BogatchevOleg 10/22/2011 16:39'!
initialize 
	super initialize.
	email := ''.
	password := ''.
	logedIn := false.
	administrator := false.
	confirmEmail := true.
	message := ''.
	module := nil.
	tempEmail := ''.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/21/2011 10:22'!
isAdministrator
	^administrator.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/19/2011 14:38'!
isLogedIn
	^logedIn.! !

!RPSS_Visitor methodsFor: 'servicies' stamp: 'TimLenertz 10/25/2011 12:59'!
login: html
	|system|
	system := RPSS_System uniqueInstance.
	(system isUserAutorized: (self email) password: (self password))
	ifTrue: 
	[
		self fromUser: email.
		logedIn := true.
		self setModule: (self session visitor: self).
	]
	ifFalse: 
	[
		self setMessage: 'Wrong login/password or user not approved by administrator!!'.
	]. 
	! !

!RPSS_Visitor methodsFor: 'servicies' stamp: 'BogatchevOleg 10/22/2011 18:31'!
logout
	password := ''.
	email := ''.
	logedIn := false.
	administrator := false.
	message := ''.
	module := nil.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/19/2011 07:02'!
message
	^message.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/20/2011 23:08'!
module
	^module.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/17/2011 11:50'!
password
	^password.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/17/2011 11:50'!
password: aPassword
	password := aPassword.! !

!RPSS_Visitor methodsFor: 'rendering' stamp: 'BogatchevOleg 10/21/2011 10:19'!
renderContentOn: html
	html paragraph: 'To login, please provide the following information'.
	html 	form: 
			[
				html 	paragraph: 'Your e-mail adress:'.
				html 	textInput callback: [:value | self email: value].
				html 	paragraph: 'Your password:'.
				html 	textInput type: 'password'; callback: [:value | self password: value].
				html 	break.
				html 	submitButton callback: [ self login:html]; value: 'Login!!'.
			].! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/19/2011 07:03'!
setMessage: aMessage.
	message := aMessage.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/20/2011 23:08'!
setModule: aModule
	module := aModule.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/22/2011 16:39'!
tempEmail
	^tempEmail.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/22/2011 16:40'!
tempEmail: anEmail
	tempEmail := anEmail.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/22/2011 18:14'!
tempPassword
	^tempPassword.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/22/2011 18:14'!
tempPassword: aPassword
	tempPassword := aPassword.! !

WASession subclass: #RPSS_Session
	instanceVariableNames: 'visitor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS'!

!RPSS_Session methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 12:47'!
user
	^ RPSS_System uniqueInstance getUserWithEmail: visitor email
	! !

!RPSS_Session methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 12:51'!
visitor
	visitor ifNil: [visitor := RPSS_Visitor new].
	^ visitor! !

!RPSS_Session methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 12:46'!
visitor: anObject
	visitor := anObject! !

Object subclass: #RPSS_CharacterClass
	instanceVariableNames: 'title attributes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS'!

!RPSS_CharacterClass methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 17:48'!
attributeName: attribute
	^ attributes keyAtValue: attribute! !

!RPSS_CharacterClass methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 14:46'!
attributes
	^ attributes! !

!RPSS_CharacterClass methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 14:46'!
attributes: anObject
	attributes := anObject! !

!RPSS_CharacterClass methodsFor: 'as yet unclassified' stamp: 'TimLenertz 10/25/2011 14:49'!
initialize
	title := 'New Character Class'.
	attributes := IdentityDictionary new.! !

!RPSS_CharacterClass methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 14:11'!
title
	^ title! !

!RPSS_CharacterClass methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 14:11'!
title: aString
	^ title := aString! !

Object subclass: #RPSS_CharacterClassAttribute
	instanceVariableNames: 'dependencies initialValue modifiable random minValue maxValue calculator maximumCalculator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS'!

!RPSS_CharacterClassAttribute methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 18:20'!
calculator
	^ calculator! !

!RPSS_CharacterClassAttribute methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 18:20'!
calculator: anObject
	calculator := anObject! !

!RPSS_CharacterClassAttribute methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 18:20'!
dependencies
	^ dependencies! !

!RPSS_CharacterClassAttribute methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 18:20'!
dependencies: anObject
	dependencies := anObject! !

!RPSS_CharacterClassAttribute methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 18:20'!
initialValue
	^ initialValue! !

!RPSS_CharacterClassAttribute methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 18:20'!
initialValue: anObject
	initialValue := anObject! !

!RPSS_CharacterClassAttribute methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 18:20'!
maxValue
	^ maxValue! !

!RPSS_CharacterClassAttribute methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 18:20'!
maxValue: anObject
	maxValue := anObject! !

!RPSS_CharacterClassAttribute methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 18:20'!
maximumCalculator
	^ maximumCalculator! !

!RPSS_CharacterClassAttribute methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 18:20'!
maximumCalculator: anObject
	maximumCalculator := anObject! !

!RPSS_CharacterClassAttribute methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 18:20'!
minValue
	^ minValue! !

!RPSS_CharacterClassAttribute methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 18:20'!
minValue: anObject
	minValue := anObject! !

!RPSS_CharacterClassAttribute methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 18:20'!
modifiable
	^ modifiable! !

!RPSS_CharacterClassAttribute methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 18:20'!
modifiable: anObject
	modifiable := anObject! !

!RPSS_CharacterClassAttribute methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 18:20'!
random
	^ random! !

!RPSS_CharacterClassAttribute methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 18:20'!
random: anObject
	random := anObject! !

Object subclass: #RPSS_MailSender
	instanceVariableNames: 'emailFrom localhost'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS'!

RPSS_MailSender class
	instanceVariableNames: 'uniqueInstance'!

RPSS_MailSender class
	instanceVariableNames: 'uniqueInstance'!

!RPSS_MailSender class methodsFor: 'instance destruction' stamp: 'BogatchevOleg 10/17/2011 17:27'!
reset
	uniqueInstance := nil.! !

!RPSS_MailSender class methodsFor: 'instance creation' stamp: 'BogatchevOleg 10/17/2011 23:01'!
uniqueInstance
	uniqueInstance ifNil: 
	[
		uniqueInstance := self new.
	].
	^uniqueInstance.! !

!RPSS_MailSender methodsFor: 'initialization' stamp: 'BogatchevOleg 10/18/2011 21:06'!
initialize
	super initialize.
	emailFrom := 'rpss@ulb.ac.be'.
	localhost := WideString fromString: 'http://localhost:8080'.! !

!RPSS_MailSender methodsFor: 'services' stamp: 'TimLenertz 10/25/2011 10:20'!
sendApprovalTo: anEmail
	self
		sendMail: 'You have been approved!!'
		subject: 'Email confirmation'
		to: anEmail.! !

!RPSS_MailSender methodsFor: 'services' stamp: 'TimLenertz 10/25/2011 10:22'!
sendApprovalToAdmin: urlApp and: urlDen for: email
	|body linkApp linkDen administrator|
	
	linkApp := localhost, urlApp greaseString.
	linkDen := localhost, urlDen greaseString.
	administrator := (RPSS_System uniqueInstance) firstAdministrator.
	body := 'A new user created an account, please validate him, his email: ', email, ' to validate ',linkApp, ' to reject ', linkDen.
	
	self
		sendMail: body
		subject: 'Email confirmation'
		to: administrator email.! !

!RPSS_MailSender methodsFor: 'services' stamp: 'TimLenertz 10/25/2011 10:23'!
sendDenialTo: anEmail
	self
		sendMail: 'You have been denied!!'
		subject: 'Email confirmation'
		to: anEmail.
! !

!RPSS_MailSender methodsFor: 'services' stamp: 'TimLenertz 10/25/2011 10:28'!
sendEmailChangeTo: anEmail with: newEmail url: aUrl
	|link body|
	link := localhost, aUrl greaseString.
	body := 'Please confirm that you want to change your mail from: ', anEmail, ' to ', newEmail,' with this link:', link.
	
	self
		sendMail: body
		subject: 'Email confirmation'
		to: anEmail.! !

!RPSS_MailSender methodsFor: 'services' stamp: 'TimLenertz 10/25/2011 10:29'!
sendEmailConfirmationTo: anEmail withUrl: url
	|link body|
	link := localhost, url greaseString.
	body := 'You can confirm your email via this link: ', link.
	
	self
		sendMail: body
		subject: 'Email confirmation'
		to: anEmail.! !

!RPSS_MailSender methodsFor: 'services' stamp: 'TimLenertz 10/25/2011 10:18'!
sendMail: body subject: subject to: receiver
	"Sends an email, using the SMTP configuration from the Seaside WAEmailConfiguration"
	
	|msg|
	msg := WAEmailMessage new.
	msg from: (WAEmailAddress address: emailFrom username: 'RPSS').
	msg addTo: (WAEmailAddress address: receiver username: receiver).
	msg subject: subject.
	msg body: (WAStringEmailBody string: body).
	msg send.! !

!RPSS_MailSender methodsFor: 'services' stamp: 'TimLenertz 10/25/2011 10:30'!
sendPasswordChangeTo: anEmail url: aUrl
	|link body|
	link := localhost, aUrl greaseString.
	body := 'Please confirm that you want to change your password with this link:', link.
	
	self
		sendMail: body
		subject: 'Email confirmation'
		to: anEmail.! !

Object subclass: #RPSS_MailSenderOLD
	instanceVariableNames: 'emailFrom localhost'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS'!

RPSS_MailSenderOLD class
	instanceVariableNames: 'uniqueInstance'!

RPSS_MailSenderOLD class
	instanceVariableNames: 'uniqueInstance'!

!RPSS_MailSenderOLD class methodsFor: 'instance destruction' stamp: 'TimLenertz 10/25/2011 10:05'!
reset
	uniqueInstance := nil.! !

!RPSS_MailSenderOLD class methodsFor: 'instance creation' stamp: 'TimLenertz 10/25/2011 10:05'!
uniqueInstance
	uniqueInstance ifNil: 
	[
		uniqueInstance := self new.
	].
	^uniqueInstance.! !

!RPSS_MailSenderOLD methodsFor: 'initialization' stamp: 'TimLenertz 10/25/2011 10:05'!
initialize
	super initialize.
	emailFrom := 'rpss@ulb.ac.be'.
	localhost := WideString fromString: 'http://localhost:8080'.! !

!RPSS_MailSenderOLD methodsFor: 'services' stamp: 'TimLenertz 10/25/2011 10:05'!
sendApprovalTo: anEmail
	|msg to from subject body bodyhtml content|
	to := MIMEHeaderValue forField: 'to' fromString: anEmail.
	from := MIMEHeaderValue forField: 'from' fromString: emailFrom.
	content := MIMEHeaderValue forField: 'content' fromString: 'text/html'.
	subject := MIMEHeaderValue fromTraditionalHeader:  'Email confirmation'.
	
	bodyhtml := 'You have been approved!! '.
	body := MIMEDocument contentType: 'text/html' content: bodyhtml.
	
	msg := (MailMessage new setField: 'to' to: to;
	setField: 'from' to: from;
	setField: 'subject' to: subject;
	setField: 'content' to: content;
	body: body yourself).
	(MailComposition new sendMailMessage: msg) submit.! !

!RPSS_MailSenderOLD methodsFor: 'services' stamp: 'TimLenertz 10/25/2011 10:05'!
sendApprovalToAdmin: urlApp and: urlDen for: email
	|msg to from subject body bodyhtml content administrator linkApp linkDen|
	administrator := (RPSS_System uniqueInstance) firstAdministrator.
	
	to := MIMEHeaderValue forField: 'to' fromString: administrator email.
	from := MIMEHeaderValue forField: 'from' fromString: emailFrom.
	content := MIMEHeaderValue forField: 'content' fromString: 'text/html'.
	subject := MIMEHeaderValue fromTraditionalHeader:  'Email confirmation'.
	
	linkApp := localhost, urlApp greaseString.
	linkDen := localhost, urlDen greaseString.
	bodyhtml := 'A new user created an account, please validate him, his email: ', email, ' to validate ',linkApp, ' to reject ', linkDen.
	body := MIMEDocument contentType: 'text/html' content: bodyhtml.
	
	msg := (MailMessage new setField: 'to' to: to;
	setField: 'from' to: from;
	setField: 'subject' to: subject;
	setField: 'content' to: content;
	body: body yourself).
	(MailComposition new sendMailMessage: msg) submit.! !

!RPSS_MailSenderOLD methodsFor: 'services' stamp: 'TimLenertz 10/25/2011 10:05'!
sendDenialTo: anEmail
	|msg to from subject body bodyhtml content|
	to := MIMEHeaderValue forField: 'to' fromString: anEmail.
	from := MIMEHeaderValue forField: 'from' fromString: emailFrom.
	content := MIMEHeaderValue forField: 'content' fromString: 'text/html'.
	subject := MIMEHeaderValue fromTraditionalHeader:  'Email confirmation'.
	
	bodyhtml := 'You have been denied!! '.
	body := MIMEDocument contentType: 'text/html' content: bodyhtml.
	
	msg := (MailMessage new setField: 'to' to: to;
	setField: 'from' to: from;
	setField: 'subject' to: subject;
	setField: 'content' to: content;
	body: body yourself).
	(MailComposition new sendMailMessage: msg) submit.! !

!RPSS_MailSenderOLD methodsFor: 'services' stamp: 'TimLenertz 10/25/2011 10:05'!
sendEmailChangeTo: anEmail with: newEmail url: aUrl
	|msg to from subject body bodyhtml link content|
	to := MIMEHeaderValue forField: 'to' fromString: anEmail.
	from := MIMEHeaderValue forField: 'from' fromString: emailFrom.
	content := MIMEHeaderValue forField: 'content' fromString: 'text/html'.
	subject := MIMEHeaderValue fromTraditionalHeader:  'Email confirmation'.
	
	link := localhost, aUrl greaseString.
	bodyhtml := 'Please confirm that you want to change your mail from: ', anEmail, ' to ', newEmail,' with this link:', link.
	body := MIMEDocument contentType: 'text/html' content: bodyhtml.
	
	msg := (MailMessage new setField: 'to' to: to;
	setField: 'from' to: from;
	setField: 'subject' to: subject;
	setField: 'content' to: content;
	body: body yourself).
	(MailComposition new sendMailMessage: msg) submit.! !

!RPSS_MailSenderOLD methodsFor: 'services' stamp: 'TimLenertz 10/25/2011 10:05'!
sendEmailConfirmationTo: anEmail withUrl: url
	|msg to from subject body bodyhtml link content|
	to := MIMEHeaderValue forField: 'to' fromString: anEmail.
	from := MIMEHeaderValue forField: 'from' fromString: emailFrom.
	content := MIMEHeaderValue forField: 'content' fromString: 'text/html'.
	subject := MIMEHeaderValue fromTraditionalHeader:  'Email confirmation'.
	
	link := localhost, url greaseString.
	bodyhtml := 'You can confirm your email via this link: ', link.
	body := MIMEDocument contentType: 'text/html' content: bodyhtml.
	
	msg := (MailMessage new setField: 'to' to: to;
	setField: 'from' to: from;
	setField: 'subject' to: subject;
	setField: 'content' to: content;
	body: body yourself).
	(MailComposition new sendMailMessage: msg) submit.! !

!RPSS_MailSenderOLD methodsFor: 'services' stamp: 'TimLenertz 10/25/2011 10:05'!
sendPasswordChangeTo: anEmail url: aUrl
	|msg to from subject body bodyhtml link content|
	to := MIMEHeaderValue forField: 'to' fromString: anEmail.
	from := MIMEHeaderValue forField: 'from' fromString: emailFrom.
	content := MIMEHeaderValue forField: 'content' fromString: 'text/html'.
	subject := MIMEHeaderValue fromTraditionalHeader:  'Email confirmation'.
	
	link := localhost, aUrl greaseString.
	bodyhtml := 'Please confirm that you want to change your password with this link:', link.
	body := MIMEDocument contentType: 'text/html' content: bodyhtml.
	
	msg := (MailMessage new setField: 'to' to: to;
	setField: 'from' to: from;
	setField: 'subject' to: subject;
	setField: 'content' to: content;
	body: body yourself).
	(MailComposition new sendMailMessage: msg) submit.! !

Object subclass: #RPSS_System
	instanceVariableNames: 'collection initialized emailConfRequired userApprovedByAdmin firstAdministrator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS'!

RPSS_System class
	instanceVariableNames: 'uniqueInstance'!

RPSS_System class
	instanceVariableNames: 'uniqueInstance'!

!RPSS_System class methodsFor: 'instance destruction' stamp: 'BogatchevOleg 10/19/2011 07:58'!
reset
	uniqueInstance := nil.
	RPSS_MailSender reset.! !

!RPSS_System class methodsFor: 'instance destruction' stamp: 'TimLenertz 10/25/2011 14:15'!
resetWithAdministrator: email password: password
	|user|
	user := (RPSS_User new fromVisitor: (RPSS_Administrator new initializeWithEmail: email password: password)).
	user approveByAdministrator.
	RPSS_System reset.
	RPSS_System uniqueInstance
		addUser: user;
		setFirstAdministrator: user;
		finishInitialization. 
	
 ! !

!RPSS_System class methodsFor: 'instance creation' stamp: 'BogatchevOleg 10/17/2011 15:15'!
uniqueInstance
	uniqueInstance ifNil: [uniqueInstance := self new].
	^uniqueInstance.! !

!RPSS_System methodsFor: 'operations' stamp: 'BogatchevOleg 10/17/2011 15:17'!
addUser: aUser
	collection at: (((aUser email) onlyLetters ) asSymbol ) put: aUser.! !

!RPSS_System methodsFor: 'operations' stamp: 'BogatchevOleg 10/21/2011 16:45'!
approveUser: anEmail
	|user mail|
	(self isEmailOccupied: anEmail)
	ifTrue: 
	[
		user := self getUserWithEmail: anEmail.
		mail := RPSS_MailSender uniqueInstance.
		user approveByAdministrator.
		mail sendApprovalTo: anEmail.
	].! !

!RPSS_System methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 12:06'!
collection
	"Collection of RPSS_User objects"
	
	^collection.! !

!RPSS_System methodsFor: 'operations' stamp: 'BogatchevOleg 10/21/2011 22:20'!
denyUser: anEmail
	|mail user|
	mail := RPSS_MailSender uniqueInstance.
	(self isEmailOccupied: anEmail)
	ifTrue: 
	[
		collection removeKey: ((anEmail onlyLetters ) asSymbol ).
		mail sendDenialTo: anEmail.
	].! !

!RPSS_System methodsFor: 'accessing' stamp: 'BogatchevOleg 10/18/2011 21:56'!
finishInitialization
	initialized := true.! !

!RPSS_System methodsFor: 'select' stamp: 'BogatchevOleg 10/19/2011 20:01'!
firstAdministrator
	^firstAdministrator.! !

!RPSS_System methodsFor: 'select' stamp: 'BogatchevOleg 10/21/2011 16:14'!
getUserWithEmail: anEmail
	^(collection at: ((anEmail) onlyLetters) asSymbol).! !

!RPSS_System methodsFor: 'initialization' stamp: 'BogatchevOleg 10/19/2011 20:01'!
initialize
	super initialize.
	collection := IdentityDictionary new.
	initialized := false.
	emailConfRequired := true.
	userApprovedByAdmin := true.
	firstAdministrator := nil.! !

!RPSS_System methodsFor: 'accessing' stamp: 'BogatchevOleg 10/17/2011 15:17'!
isEmailConfRequired
	^emailConfRequired.! !

!RPSS_System methodsFor: 'testing' stamp: 'BogatchevOleg 10/18/2011 21:23'!
isEmailOccupied: anEmail
	^(collection includesKey:  (((anEmail) onlyLetters ) asSymbol )).! !

!RPSS_System methodsFor: 'accessing' stamp: 'BogatchevOleg 10/17/2011 17:47'!
isInitialized 
	^initialized.! !

!RPSS_System methodsFor: 'accessing' stamp: 'BogatchevOleg 10/17/2011 17:49'!
isUserApprovedByAdmin
	^userApprovedByAdmin.! !

!RPSS_System methodsFor: 'testing' stamp: 'BogatchevOleg 10/21/2011 16:09'!
isUserAutorized: anEmail password: aPassword
	|user|
	(collection includesKey: ((anEmail onlyLetters ) asSymbol))
	ifTrue: 
	[
		user := self getUserWithEmail: anEmail.
		((user password = aPassword) & (user approvedByAdministrator = true)) 
		ifTrue: 
		[
			^true.
		].
	].
	^false.! !

!RPSS_System methodsFor: 'operations' stamp: 'BogatchevOleg 10/19/2011 20:03'!
setFirstAdministrator: newAdministrator
	^firstAdministrator := newAdministrator.! !

!RPSS_System methodsFor: 'operations' stamp: 'BogatchevOleg 10/22/2011 17:09'!
transferUserFrom: anEmail to: newEmail
	|user|
	user := self getUserWithEmail: anEmail.
	collection removeKey: (((anEmail) onlyLetters) asSymbol).
	collection at: (((newEmail) onlyLetters) asSymbol) put: user.
	user email: newEmail.


	! !

!RPSS_System methodsFor: 'accessing' stamp: 'BogatchevOleg 10/17/2011 17:47'!
userApprovedByAdmin
	^userApprovedByAdmin.! !

!RPSS_System methodsFor: 'accessing' stamp: 'BogatchevOleg 10/17/2011 17:48'!
userApprovedByAdmin: newValue
	userApprovedByAdmin := newValue.! !

!RPSS_System methodsFor: 'select' stamp: 'BogatchevOleg 10/21/2011 23:00'!
usersToApprove
	^collection select: [:user | user isNotApprovedByAdministrator & user isEmailConfirmed ]! !

!RPSS_System methodsFor: 'servicies' stamp: 'BogatchevOleg 10/17/2011 19:16'!
verifyEmail: anEmail
	^true.! !

!RPSS_System methodsFor: 'servicies' stamp: 'BogatchevOleg 10/17/2011 19:16'!
verifyPassword: aPassword
	^true.! !

Object subclass: #RPSS_User
	instanceVariableNames: 'email password administrator emailConfirmed approvedByAdministrator characterClasses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS'!

!RPSS_User methodsFor: 'accessing' stamp: 'BogatchevOleg 10/21/2011 16:19'!
administrator
	^administrator.! !

!RPSS_User methodsFor: 'accessing' stamp: 'BogatchevOleg 10/21/2011 16:19'!
administrator: value
	administrator := value.! !

!RPSS_User methodsFor: 'accessing' stamp: 'BogatchevOleg 10/18/2011 21:14'!
approveByAdministrator
	approvedByAdministrator := true.! !

!RPSS_User methodsFor: 'accessing' stamp: 'BogatchevOleg 10/21/2011 16:09'!
approvedByAdministrator
	^approvedByAdministrator.! !

!RPSS_User methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 12:10'!
approvedByAdministrator: anObject
	approvedByAdministrator := anObject! !

!RPSS_User methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 12:10'!
characterClasses
	^ characterClasses! !

!RPSS_User methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 12:10'!
characterClasses: anObject
	characterClasses := anObject! !

!RPSS_User methodsFor: 'accessing' stamp: 'BogatchevOleg 10/18/2011 21:12'!
email
	^email.! !

!RPSS_User methodsFor: 'accessing' stamp: 'BogatchevOleg 10/18/2011 21:12'!
email: anEmail
	email := anEmail.! !

!RPSS_User methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 12:10'!
emailConfirmed: anObject
	^ emailConfirmed := anObject! !

!RPSS_User methodsFor: 'instance creation' stamp: 'BogatchevOleg 10/19/2011 16:50'!
fromVisitor: aVisitor
	email := aVisitor email.
	password := aVisitor password.
	administrator := false.
	emailConfirmed := false.
	approvedByAdministrator := false.! !

!RPSS_User methodsFor: 'initialization' stamp: 'TimLenertz 10/25/2011 12:10'!
initialize
	super initialize.
	email := ''.
	password := ''.
	emailConfirmed := false.
	approvedByAdministrator := false.
	characterClasses := OrderedCollection new.! !

!RPSS_User methodsFor: 'accessing' stamp: 'BogatchevOleg 10/19/2011 19:58'!
isAdministrator
	^administrator.! !

!RPSS_User methodsFor: 'accessing' stamp: 'BogatchevOleg 10/21/2011 22:46'!
isApprovedByAdministrator
	^approvedByAdministrator.! !

!RPSS_User methodsFor: 'accessing' stamp: 'BogatchevOleg 10/21/2011 22:45'!
isEmailConfirmed
	^emailConfirmed.! !

!RPSS_User methodsFor: 'accessing' stamp: 'BogatchevOleg 10/21/2011 22:47'!
isNotApprovedByAdministrator
	^(approvedByAdministrator not).! !

!RPSS_User methodsFor: 'accessing' stamp: 'BogatchevOleg 10/18/2011 21:13'!
markAsAdministrator
	administrator := true.! !

!RPSS_User methodsFor: 'accessing' stamp: 'BogatchevOleg 10/18/2011 21:14'!
markEmailConfirmed
	^emailConfirmed := true.! !

!RPSS_User methodsFor: 'accessing' stamp: 'BogatchevOleg 10/18/2011 21:12'!
password
	^password.! !

!RPSS_User methodsFor: 'accessing' stamp: 'BogatchevOleg 10/18/2011 21:12'!
password: aPassword
	password := aPassword.! !
